local mod = MorgDKP2:NewModule("Random")
local L = LibStub("AceLocale-3.0"):GetLocale("MorgDKP2")

local mdkp = MorgDKP2
local db 
	
mod.modName = L["Random rolls"]
mod.modref = "Random"

local Player = UnitName("player")
local fmt = string.format

local defaults = { 
	profile = {
		
	},
}

function mod:GetOptions()
	return options
end

function mod:IsDKP()
	return true
end

function mod:GetName()
	return mod.modName, mod.modref
end

function mod:OnInitialize()
	self.db = mdkp.db:RegisterNamespace("Random", defaults)
	
end

function mod:OnEnable()
	db = mdkp.db.profile	
	db.moduleON["Random"] = true
end

function mod:OnDisable()
	db.moduleON["Random"] = nil
end

function mod:UpdateDB()
	db = mdkp.db.profile
end

function mod:Toggle(info, v)
	mdkp.db.profile.modules.Random = v
	if v then mod:Enable()
	else mod:Disable() end
	self:DKPChange(mod.modName)
end

function mod:GetPlayerPoints(name, POOL, showearned)
	if not showearned or showearned == 1 then return db.info[name][POOL].points end
	if showearned == 2 then return db.info[name][POOL].earned
	elseif showearned == 3 then return db.info[name][POOL].attend
	end
end

function mod:GetItemValue(itemid)
	return 0
end

function mod:ItemRecorded(id, looter, POOL, points, itempoints, link)
	if looter == L["Bank"] then return end
	self:ToggleRaidloot(looter)
	db.info[looter].lastupdate = self:GetServerTime()
	self:out(fmt(L["%s received %s."], looter, link))
end

function mod:ItemRebate(id, looter, POOL, itempoints, link)
	
end
